-- REQUIRED Combuctor
local CombuctorSet = Combuctor:GetModule("Sets")

-- Localization
local L = LibStub("AceLocale-3.0"):GetLocale("Combuctor_Minage")

-- Profession Icon Name
local IconPathName = "Interface/Icons/Trade_Mining"

-- AucItemClasses
local Class_Other = select(13, GetAuctionItemSubClasses(6))

local SpellID = 2575
local Mining = GetSpellInfo(SpellID)
if not Mining then
	Mining = L["Mining"]
end 

-- Tab Names
local TN = {}
TN.All = ALL
TN.Mining = Mining
TN.Other = Class_Other

-----------------------------------------------------------------------------------------------------------------------------------------

local function GetItemIDFromLink(itemLink)
	if not itemLink or itemLink=="" then return nil end

	local itemString = string.match(itemLink, "item[%-?%d:]+")
	local linkType, itemId, enchantId,jewelId1, jewelId2, jewelId3, jewelId4,suffixId, uniqueId = strsplit(":", itemString)
	if (linkType == 'item') then
		return itemId
	end

end

-----------------------------------------------------------------------------------------------------------------------------------------

function TN.isMetalStone(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	return TN.isOre(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
		or TN.isBar(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	    or TN.isStone(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
		or TN.isOther(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc);
end

-----------------------------------------------------------------------------------------------------------------------------------------

function TN.isOre(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	if not link then return false end

	local ItemID=GetItemIDFromLink(link)
	if not ItemID then return false end
	
	return Ores[tonumber(ItemID)];
end

-----------------------------------------------------------------------------------------------------------------------------------------

function TN.isBar(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	if not link then return false end

	local ItemID=GetItemIDFromLink(link)
	if not ItemID then return false end
	
	return Bars[tonumber(ItemID)];
end

-----------------------------------------------------------------------------------------------------------------------------------------

function TN.isStone(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	if not link then return false end

	local ItemID=GetItemIDFromLink(link)
	if not ItemID then return false end
	
	return Stones[tonumber(ItemID)];
end

-----------------------------------------------------------------------------------------------------------------------------------------

function TN.isOther(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	if not link then return false end

	local ItemID=GetItemIDFromLink(link)
	if not ItemID then return false end
	
	return Others[tonumber(ItemID)];
end
-----------------------------------------------------------------------------------------------------------------------------------------

CombuctorSet:Register(TN.Mining, IconPathName, TN.isMetalStone)

CombuctorSet:RegisterSubSet(TN.All,				TN.Mining, nil, TN.isMetalStone)
CombuctorSet:RegisterSubSet(L["Ore"],			TN.Mining, nil, TN.isOre)
CombuctorSet:RegisterSubSet(L["Bar"],			TN.Mining, nil, TN.isBar)
CombuctorSet:RegisterSubSet(L["Stone"],		TN.Mining, nil, TN.isStone)
CombuctorSet:RegisterSubSet(TN.Other,		TN.Mining, nil, TN.isOther)
